'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.devToolsInstrument = exports.StorybookReduxAddon = undefined;

var _addons = require('@storybook/addons');

var _addons2 = _interopRequireDefault(_addons);

var _StorybookReduxAddon = require('./StorybookReduxAddon');

var _StorybookReduxAddon2 = _interopRequireDefault(_StorybookReduxAddon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var store = _ref.store,
      children = _ref.children;

  var channel = _addons2.default.getChannel();

  window.__STORE__ = store;
  channel.emit('addons/redux/add_store');

  return children;
};

exports.StorybookReduxAddon = _StorybookReduxAddon2.default;
exports.devToolsInstrument = _StorybookReduxAddon.devToolsInstrument;