'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _addons = require('@storybook/addons');

var _addons2 = _interopRequireDefault(_addons);

var _StorybookReduxAddon = require('./StorybookReduxAddon');

var _StorybookReduxAddon2 = _interopRequireDefault(_StorybookReduxAddon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReduxPanel = function (_Component) {
  (0, _inherits3.default)(ReduxPanel, _Component);

  function ReduxPanel(props) {
    (0, _classCallCheck3.default)(this, ReduxPanel);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ReduxPanel.__proto__ || (0, _getPrototypeOf2.default)(ReduxPanel)).call(this, props));

    _this.state = { store: null };
    _this._addStore = _this._addStore.bind(_this);
    _this._removeStore = _this._removeStore.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(ReduxPanel, [{
    key: '_addStore',
    value: function _addStore() {
      this.setState({ store: document.getElementById('storybook-preview-iframe').contentWindow.__STORE__ });
    }
  }, {
    key: '_removeStore',
    value: function _removeStore() {
      document.getElementById('storybook-preview-iframe').contentWindow.__STORE__ = null;
      this.setState({ store: null });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          channel = _props.channel,
          api = _props.api;


      channel.on('addons/redux/add_store', this._addStore);
      this._stopListeningOnStory = api.onStory(this._removeStore);
    }
  }, {
    key: 'render',
    value: function render() {
      var store = this.state.store;

      var content = store ? _react2.default.createElement(_StorybookReduxAddon2.default, { store: store }) : null;

      return content;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var channel = this.props.channel;


      if (this._stopListeningOnStory) {
        this._stopListeningOnStory();
      }

      channel.removeListener('addons/redux/add_store', this._addStore);
    }
  }]);
  return ReduxPanel;
}(_react.Component);

_addons2.default.register('addons/redux', function (api) {
  return _addons2.default.addPanel('addons/redux/panel', {
    title: 'Redux',
    render: function render() {
      return _react2.default.createElement(ReduxPanel, {
        channel: _addons2.default.getChannel(),
        api: api });
    }
  });
});