'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.devToolsInstrument = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxDevtools = require('redux-devtools');

var _reduxDevtoolsLogMonitor = require('redux-devtools-log-monitor');

var _reduxDevtoolsLogMonitor2 = _interopRequireDefault(_reduxDevtoolsLogMonitor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StorybookReduxAddon = (0, _reduxDevtools.createDevTools)(_react2.default.createElement(_reduxDevtoolsLogMonitor2.default, null));

var devToolsInstrument = StorybookReduxAddon.instrument;

exports.default = StorybookReduxAddon;
exports.devToolsInstrument = devToolsInstrument;