import addons from '@storybook/addons'
import StorybookReduxAddon, { devToolsInstrument } from './StorybookReduxAddon'

export default ({ store, children }) => {
  const channel = addons.getChannel()

  window.__STORE__ = store
  channel.emit('addons/redux/add_store')

  return children
}

export { StorybookReduxAddon, devToolsInstrument }
